/* WebView.c generated by valac 0.54.6, the Vala compiler
 * generated from WebView.vala, do not modify */

/*
* Copyright (c) 2017-2021 Lains
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
*/

#include <webkit2/webkit2.h>
#include <glib-object.h>
#include <gtksourceview/gtksource.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <handy.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <cairo-gobject.h>
#include "mkdio.h"

#define QUILTER_STYLES_QUILTERDARK_css "\n" \
"    html {\n" \
"      font-size: 13pt;\n" \
"      width: 100%;\n" \
"      margin: 0 auto;\n" \
"    }\n" \
"\n" \
"    p {\n" \
"      font-size: 13pt;\n" \
"      line-height: 1.618rem;\n" \
"      color: #C3C3C1;\n" \
"    }\n" \
"\n" \
"    h1,\n" \
"    h2,\n" \
"    h3,\n" \
"    h4,\n" \
"    h5,\n" \
"    h6 {\n" \
"      font-style: bold;\n" \
"      margin-top: 1em;\n" \
"      line-height: 1.618rem;\n" \
"    }\n" \
"\n" \
"    h1 {\n" \
"      font-size: 2em;\n" \
"      text-transform: uppercase;\n" \
"    }\n" \
"\n" \
"    h2 {\n" \
"      font-size: 1.5em;\n" \
"    }\n" \
"\n" \
"    h3 {\n" \
"      font-size: 1.17em;\n" \
"    }\n" \
"\n" \
"    h4 {\n" \
"      font-size: 1.12em;\n" \
"    }\n" \
"\n" \
"    h5 {\n" \
"      font-size: .83em;\n" \
"    }\n" \
"\n" \
"    h6 {\n" \
"      font-size: .75em;\n" \
"    }\n" \
"\n" \
"    small {\n" \
"      font-size: .7em;\n" \
"    }\n" \
"\n" \
"    img,\n" \
"    canvas,\n" \
"    iframe,\n" \
"    video,\n" \
"    select,\n" \
"    textarea {\n" \
"      display: block;\n" \
"      max-width: 50%;\n" \
"    }\n" \
"\n" \
"    body {\n" \
"      color: #C3C3C3;\n" \
"      background-color: #111111;\n" \
"      font-weight: 400;\n" \
"      line-height: 1.618rem;\n" \
"      margin-left: 3rem;\n" \
"      margin-right: 3rem;\n" \
"      margin-top: 3rem;\n" \
"      margin-bottom: 3rem;\n" \
"      text-align: left;\n" \
"    }\n" \
"\n" \
"    table {\n" \
"      border-spacing: 0;\n" \
"      border-collapse: collapse;\n" \
"      margin-top: 0;\n" \
"      margin-bottom: 16px;\n" \
"    }\n" \
"\n" \
"    table th {\n" \
"      font-weight: bold;\n" \
"      background-color: #2b2b2b;\n" \
"    }\n" \
"\n" \
"    table th,\n" \
"    table td {\n" \
"      padding: 8px 13px;\n" \
"      border: 1px solid #2b2b2b;\n" \
"    }\n" \
"\n" \
"    table tr {\n" \
"      border-top: 1px solid #2b2b2b;\n" \
"    }\n" \
"\n" \
"    img {\n" \
"      height: auto;\n" \
"      margin: 0 auto;\n" \
"    }\n" \
"\n" \
"    a,\n" \
"    a:visited,\n" \
"    a:hover,\n" \
"    a:focus,\n" \
"    a:active {\n" \
"      color: #1d99f3;\n" \
"    }\n" \
"\n" \
"    code{\n" \
"      display: inline-block;\n" \
"      padding: 0 0.25rem;\n" \
"      background-color: #23241c;\n" \
"      border: 1px solid #23241c;\n" \
"      border-radius: 4px;\n" \
"      font-family: 'Quilt Mono', monospace;\n" \
"      font-weight: normal;\n" \
"    }\n" \
"\n" \
"    pre code{\n" \
"      display: block;\n" \
"      margin: 1rem auto;\n" \
"      overflow-x: scroll;\n" \
"      padding: 0.5em;\n" \
"    }\n" \
"\n" \
"    blockquote {\n" \
"      margin: 0;\n" \
"      border-left: 5px solid #7E8087;\n" \
"      font-style: italic;\n" \
"      padding-left: .8rem;\n" \
"      margin-left: .8rem;\n" \
"      text-align: left;\n" \
"    }\n" \
"\n" \
"    blockquote > p {\n" \
"      color: inherit;\n" \
"      margin-top: 20px;\n" \
"      margin-bottom: 20px;\n" \
"      padding-top: 20px;\n" \
"      padding-bottom: 20px;\n" \
"    }\n" \
"\n" \
"    ul {\n" \
"      list-style: disc;\n" \
"    }\n" \
"\n" \
"    ul>li {\n" \
"      font-size: 18px;\n" \
"    }\n" \
"\n" \
"    hr {\n" \
"      overflow: visible;\n" \
"      padding: 0;\n" \
"      border: none;\n" \
"      color: inherit;\n" \
"      text-align: center;\n" \
"    }\n" \
"    hr:after {\n" \
"      content: \"...\";\n" \
"      letter-spacing: .6em;\n" \
"      display: inline-block;\n" \
"      position: relative;\n" \
"      top: -0.3rem;\n" \
"      font-size: 1.65em;\n" \
"      padding: 0 0.25em;\n" \
"      background: inherit;\n" \
"    }\n" \
"  "
#define QUILTER_STYLES_QUILTERSEPIA_css "\n" \
"    html {\n" \
"      font-size: 13pt;\n" \
"      width: 100%;\n" \
"      margin: 0 auto;\n" \
"    }\n" \
"\n" \
"    p {\n" \
"      font-size: 13pt;\n" \
"      line-height: 1.618rem;\n" \
"      color: #3b3228;\n" \
"    }\n" \
"\n" \
"    h1,\n" \
"    h2,\n" \
"    h3,\n" \
"    h4,\n" \
"    h5,\n" \
"    h6 {\n" \
"      font-style: bold;\n" \
"      margin-top: 1em;\n" \
"      line-height: 1.618rem;\n" \
"    }\n" \
"\n" \
"    h1 {\n" \
"      font-size: 2em;\n" \
"      text-transform: uppercase;\n" \
"    }\n" \
"\n" \
"    h2 {\n" \
"      font-size: 1.5em;\n" \
"    }\n" \
"\n" \
"    h3 {\n" \
"      font-size: 1.17em;\n" \
"    }\n" \
"\n" \
"    h4 {\n" \
"      font-size: 1.12em;\n" \
"    }\n" \
"\n" \
"    h5 {\n" \
"      font-size: .83em;\n" \
"    }\n" \
"\n" \
"    h6 {\n" \
"      font-size: .75em;\n" \
"    }\n" \
"\n" \
"    small {\n" \
"      font-size: .7em;\n" \
"    }\n" \
"\n" \
"    img,\n" \
"    canvas,\n" \
"    iframe,\n" \
"    video,\n" \
"    select,\n" \
"    textarea {\n" \
"      display: block;\n" \
"      max-width: 50%;\n" \
"    }\n" \
"\n" \
"    body {\n" \
"      color: #3b3228;\n" \
"      background-color: #f8f4ef;\n" \
"      font-weight: 400;\n" \
"      line-height: 1.618rem;\n" \
"      margin-left: 3rem;\n" \
"      margin-right: 3rem;\n" \
"      margin-top: 3rem;\n" \
"      margin-bottom: 3rem;\n" \
"      text-align: left;\n" \
"    }\n" \
"\n" \
"    table {\n" \
"      border-spacing: 0;\n" \
"      border-collapse: collapse;\n" \
"      margin-top: 0;\n" \
"      margin-bottom: 16px;\n" \
"    }\n" \
"\n" \
"    table th {\n" \
"      font-weight: bold;\n" \
"      background-color: #e0d0b9;\n" \
"    }\n" \
"\n" \
"    table th,\n" \
"    table td {\n" \
"      padding: 8px 13px;\n" \
"      border: 1px solid #e0d0b9;\n" \
"    }\n" \
"\n" \
"    table tr {\n" \
"      border-top: 1px solid #e0d0b9;\n" \
"    }\n" \
"\n" \
"    img {\n" \
"      height: auto;\n" \
"      margin: 0 auto;\n" \
"    }\n" \
"\n" \
"    a,\n" \
"    a:visited,\n" \
"    a:hover,\n" \
"    a:focus,\n" \
"    a:active {\n" \
"      color: #00897b;\n" \
"    }\n" \
"\n" \
"    code{\n" \
"      display: inline-block;\n" \
"      padding: 0 0.25rem;\n" \
"      background-color: #e0d0b9;\n" \
"      border: 1px solid #e0d0b9;\n" \
"      border-radius: 4px;\n" \
"      font-family: 'Quilt Mono', monospace;\n" \
"      font-weight: normal;\n" \
"    }\n" \
"\n" \
"    pre code{\n" \
"      display: block;\n" \
"      margin: 1rem auto;\n" \
"      overflow-x: scroll;\n" \
"      padding: 0.5em;\n" \
"    }\n" \
"\n" \
"    blockquote {\n" \
"      margin: 0;\n" \
"      border-left: 5px solid #7e6e62;\n" \
"      font-style: italic;\n" \
"      padding-left: .8rem;\n" \
"      margin-left: .8rem;\n" \
"      text-align: left;\n" \
"    }\n" \
"\n" \
"    blockquote > p {\n" \
"      color: inherit;\n" \
"      margin-top: 20px;\n" \
"      margin-bottom: 20px;\n" \
"      padding-top: 20px;\n" \
"      padding-bottom: 20px;\n" \
"    }\n" \
"\n" \
"    ul {\n" \
"      list-style: disc;\n" \
"    }\n" \
"\n" \
"    ul>li {\n" \
"      font-size: 18px;\n" \
"    }\n" \
"\n" \
"    hr {\n" \
"      overflow: visible;\n" \
"      padding: 0;\n" \
"      border: none;\n" \
"      color: inherit;\n" \
"      text-align: center;\n" \
"    }\n" \
"    hr:after {\n" \
"      content: \"...\";\n" \
"      letter-spacing: .6em;\n" \
"      display: inline-block;\n" \
"      position: relative;\n" \
"      top: -0.3rem;\n" \
"      font-size: 1.65em;\n" \
"      padding: 0 0.25em;\n" \
"      background: inherit;\n" \
"    }\n" \
"  "
#define QUILTER_STYLES_QUILTER_css "\n" \
"    html {\n" \
"      font-size: 13pt;\n" \
"      width: 100%;\n" \
"      margin: 0 auto;\n" \
"    }\n" \
"\n" \
"    p {\n" \
"      font-size: 13pt;\n" \
"      line-height: 1.618rem;\n" \
"      color: #191919;\n" \
"    }\n" \
"\n" \
"    h1,\n" \
"    h2,\n" \
"    h3,\n" \
"    h4,\n" \
"    h5,\n" \
"    h6 {\n" \
"      font-style: bold;\n" \
"      margin-top: 1em;\n" \
"      line-height: 1.618rem;\n" \
"    }\n" \
"\n" \
"    h1 {\n" \
"      font-size: 2em;\n" \
"      text-transform: uppercase;\n" \
"    }\n" \
"\n" \
"    h2 {\n" \
"      font-size: 1.5em;\n" \
"    }\n" \
"\n" \
"    h3 {\n" \
"      font-size: 1.17em;\n" \
"    }\n" \
"\n" \
"    h4 {\n" \
"      font-size: 1.12em;\n" \
"    }\n" \
"\n" \
"    h5 {\n" \
"      font-size: .83em;\n" \
"    }\n" \
"\n" \
"    h6 {\n" \
"      font-size: .75em;\n" \
"    }\n" \
"\n" \
"    small {\n" \
"      font-size: .7em;\n" \
"    }\n" \
"\n" \
"    img,\n" \
"    canvas,\n" \
"    iframe,\n" \
"    video,\n" \
"    select,\n" \
"    textarea {\n" \
"      display: block;\n" \
"      max-width: 50%;\n" \
"    }\n" \
"\n" \
"    body {\n" \
"      color: #333;\n" \
"      background-color: #FFF;\n" \
"      line-height: 1.618rem;\n" \
"      margin-left: 3rem;\n" \
"      margin-right: 3rem;\n" \
"      margin-top: 3rem;\n" \
"      margin-bottom: 3rem;\n" \
"    }\n" \
"\n" \
"    table {\n" \
"      border-spacing: 0;\n" \
"      border-collapse: collapse;\n" \
"      margin-top: 0;\n" \
"      margin-bottom: 16px;\n" \
"    }\n" \
"\n" \
"    table th {\n" \
"      font-weight: bold;\n" \
"      background-color: #dddddd;\n" \
"    }\n" \
"\n" \
"    table th,\n" \
"    table td {\n" \
"      padding: 8px 13px;\n" \
"      border: 1px solid #F0F0F0;\n" \
"    }\n" \
"\n" \
"    table tr {\n" \
"      border-top: 1px solid #F0F0F0;\n" \
"    }\n" \
"\n" \
"    img {\n" \
"      height: auto;\n" \
"      margin: 0 auto;\n" \
"    }\n" \
"\n" \
"    a,\n" \
"    a:visited,\n" \
"    a:hover,\n" \
"    a:focus,\n" \
"    a:active {\n" \
"      color: #0073c5;\n" \
"    }\n" \
"\n" \
"    code{\n" \
"      display: inline-block;\n" \
"      padding: 0 0.25rem;\n" \
"      background-color: #F0F0F0;\n" \
"      border: 1px solid #F0F0F0;\n" \
"      border-radius: 4px;\n" \
"      font-family: 'Quilt Mono', monospace;\n" \
"      font-weight: normal;\n" \
"    }\n" \
"\n" \
"    pre code{\n" \
"      display: block;\n" \
"      margin: 1rem auto;\n" \
"      overflow-x: scroll;\n" \
"      padding: 0.5em;\n" \
"    }\n" \
"\n" \
"    blockquote {\n" \
"      margin: 0;\n" \
"      border-left: 5px solid #8d8d8d;\n" \
"      font-style: italic;\n" \
"      padding-left: .8rem;\n" \
"      margin-left: .8rem;\n" \
"      text-align: left;\n" \
"    }\n" \
"\n" \
"    blockquote > p {\n" \
"      color: inherit;\n" \
"      margin-top: 20px;\n" \
"      margin-bottom: 20px;\n" \
"      padding-top: 20px;\n" \
"      padding-bottom: 20px;\n" \
"    }\n" \
"\n" \
"    ul {\n" \
"      list-style: disc;\n" \
"    }\n" \
"\n" \
"    ul>li {\n" \
"      font-size: 18px;\n" \
"    }\n" \
"\n" \
"    hr {\n" \
"      overflow: visible;\n" \
"      padding: 0;\n" \
"      border: none;\n" \
"      color: inherit;\n" \
"      text-align: center;\n" \
"    }\n" \
"    hr:after {\n" \
"      content: \"...\";\n" \
"      letter-spacing: .6em;\n" \
"      display: inline-block;\n" \
"      position: relative;\n" \
"      top: -0.3rem;\n" \
"      font-size: 1.65em;\n" \
"      padding: 0 0.25em;\n" \
"      background: inherit;\n" \
"    }\n" \
"  "
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define QUILTER_WIDGETS_TYPE_PREVIEW (quilter_widgets_preview_get_type ())
#define QUILTER_WIDGETS_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), QUILTER_WIDGETS_TYPE_PREVIEW, QuilterWidgetsPreview))
#define QUILTER_WIDGETS_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), QUILTER_WIDGETS_TYPE_PREVIEW, QuilterWidgetsPreviewClass))
#define QUILTER_WIDGETS_IS_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), QUILTER_WIDGETS_TYPE_PREVIEW))
#define QUILTER_WIDGETS_IS_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), QUILTER_WIDGETS_TYPE_PREVIEW))
#define QUILTER_WIDGETS_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), QUILTER_WIDGETS_TYPE_PREVIEW, QuilterWidgetsPreviewClass))

typedef struct _QuilterWidgetsPreview QuilterWidgetsPreview;
typedef struct _QuilterWidgetsPreviewClass QuilterWidgetsPreviewClass;
typedef struct _QuilterWidgetsPreviewPrivate QuilterWidgetsPreviewPrivate;

#define QUILTER_WIDGETS_TYPE_EDIT_VIEW (quilter_widgets_edit_view_get_type ())
#define QUILTER_WIDGETS_EDIT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), QUILTER_WIDGETS_TYPE_EDIT_VIEW, QuilterWidgetsEditView))
#define QUILTER_WIDGETS_EDIT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), QUILTER_WIDGETS_TYPE_EDIT_VIEW, QuilterWidgetsEditViewClass))
#define QUILTER_WIDGETS_IS_EDIT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), QUILTER_WIDGETS_TYPE_EDIT_VIEW))
#define QUILTER_WIDGETS_IS_EDIT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), QUILTER_WIDGETS_TYPE_EDIT_VIEW))
#define QUILTER_WIDGETS_EDIT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), QUILTER_WIDGETS_TYPE_EDIT_VIEW, QuilterWidgetsEditViewClass))

typedef struct _QuilterWidgetsEditView QuilterWidgetsEditView;
typedef struct _QuilterWidgetsEditViewClass QuilterWidgetsEditViewClass;
enum  {
	QUILTER_WIDGETS_PREVIEW_0_PROPERTY,
	QUILTER_WIDGETS_PREVIEW_SCROLL_VALUE_PROPERTY,
	QUILTER_WIDGETS_PREVIEW_NUM_PROPERTIES
};
static GParamSpec* quilter_widgets_preview_properties[QUILTER_WIDGETS_PREVIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define QUILTER_TYPE_MAIN_WINDOW (quilter_main_window_get_type ())
#define QUILTER_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), QUILTER_TYPE_MAIN_WINDOW, QuilterMainWindow))
#define QUILTER_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), QUILTER_TYPE_MAIN_WINDOW, QuilterMainWindowClass))
#define QUILTER_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), QUILTER_TYPE_MAIN_WINDOW))
#define QUILTER_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), QUILTER_TYPE_MAIN_WINDOW))
#define QUILTER_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), QUILTER_TYPE_MAIN_WINDOW, QuilterMainWindowClass))

typedef struct _QuilterMainWindow QuilterMainWindow;
typedef struct _QuilterMainWindowClass QuilterMainWindowClass;
typedef struct _QuilterMainWindowPrivate QuilterMainWindowPrivate;

#define QUILTER_WIDGETS_TYPE_HEADERBAR (quilter_widgets_headerbar_get_type ())
#define QUILTER_WIDGETS_HEADERBAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), QUILTER_WIDGETS_TYPE_HEADERBAR, QuilterWidgetsHeaderbar))
#define QUILTER_WIDGETS_HEADERBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), QUILTER_WIDGETS_TYPE_HEADERBAR, QuilterWidgetsHeaderbarClass))
#define QUILTER_WIDGETS_IS_HEADERBAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), QUILTER_WIDGETS_TYPE_HEADERBAR))
#define QUILTER_WIDGETS_IS_HEADERBAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), QUILTER_WIDGETS_TYPE_HEADERBAR))
#define QUILTER_WIDGETS_HEADERBAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), QUILTER_WIDGETS_TYPE_HEADERBAR, QuilterWidgetsHeaderbarClass))

typedef struct _QuilterWidgetsHeaderbar QuilterWidgetsHeaderbar;
typedef struct _QuilterWidgetsHeaderbarClass QuilterWidgetsHeaderbarClass;

#define QUILTER_WIDGETS_TYPE_SEARCH_BAR (quilter_widgets_search_bar_get_type ())
#define QUILTER_WIDGETS_SEARCH_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), QUILTER_WIDGETS_TYPE_SEARCH_BAR, QuilterWidgetsSearchBar))
#define QUILTER_WIDGETS_SEARCH_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), QUILTER_WIDGETS_TYPE_SEARCH_BAR, QuilterWidgetsSearchBarClass))
#define QUILTER_WIDGETS_IS_SEARCH_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), QUILTER_WIDGETS_TYPE_SEARCH_BAR))
#define QUILTER_WIDGETS_IS_SEARCH_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), QUILTER_WIDGETS_TYPE_SEARCH_BAR))
#define QUILTER_WIDGETS_SEARCH_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), QUILTER_WIDGETS_TYPE_SEARCH_BAR, QuilterWidgetsSearchBarClass))

typedef struct _QuilterWidgetsSearchBar QuilterWidgetsSearchBar;
typedef struct _QuilterWidgetsSearchBarClass QuilterWidgetsSearchBarClass;

#define QUILTER_WIDGETS_TYPE_STATUS_BAR (quilter_widgets_status_bar_get_type ())
#define QUILTER_WIDGETS_STATUS_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), QUILTER_WIDGETS_TYPE_STATUS_BAR, QuilterWidgetsStatusBar))
#define QUILTER_WIDGETS_STATUS_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), QUILTER_WIDGETS_TYPE_STATUS_BAR, QuilterWidgetsStatusBarClass))
#define QUILTER_WIDGETS_IS_STATUS_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), QUILTER_WIDGETS_TYPE_STATUS_BAR))
#define QUILTER_WIDGETS_IS_STATUS_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), QUILTER_WIDGETS_TYPE_STATUS_BAR))
#define QUILTER_WIDGETS_STATUS_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), QUILTER_WIDGETS_TYPE_STATUS_BAR, QuilterWidgetsStatusBarClass))

typedef struct _QuilterWidgetsStatusBar QuilterWidgetsStatusBar;
typedef struct _QuilterWidgetsStatusBarClass QuilterWidgetsStatusBarClass;

#define QUILTER_WIDGETS_TYPE_SIDE_BAR (quilter_widgets_side_bar_get_type ())
#define QUILTER_WIDGETS_SIDE_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), QUILTER_WIDGETS_TYPE_SIDE_BAR, QuilterWidgetsSideBar))
#define QUILTER_WIDGETS_SIDE_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), QUILTER_WIDGETS_TYPE_SIDE_BAR, QuilterWidgetsSideBarClass))
#define QUILTER_WIDGETS_IS_SIDE_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), QUILTER_WIDGETS_TYPE_SIDE_BAR))
#define QUILTER_WIDGETS_IS_SIDE_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), QUILTER_WIDGETS_TYPE_SIDE_BAR))
#define QUILTER_WIDGETS_SIDE_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), QUILTER_WIDGETS_TYPE_SIDE_BAR, QuilterWidgetsSideBarClass))

typedef struct _QuilterWidgetsSideBar QuilterWidgetsSideBar;
typedef struct _QuilterWidgetsSideBarClass QuilterWidgetsSideBarClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _mkd_cleanup0(var) ((var == NULL) ? NULL : (var = (mkd_cleanup (var), NULL)))

#define QUILTER_PLUGINS_TYPE_PLUGIN_MANAGER (quilter_plugins_plugin_manager_get_type ())
#define QUILTER_PLUGINS_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), QUILTER_PLUGINS_TYPE_PLUGIN_MANAGER, QuilterPluginsPluginManager))
#define QUILTER_PLUGINS_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), QUILTER_PLUGINS_TYPE_PLUGIN_MANAGER, QuilterPluginsPluginManagerClass))
#define QUILTER_PLUGINS_IS_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), QUILTER_PLUGINS_TYPE_PLUGIN_MANAGER))
#define QUILTER_PLUGINS_IS_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), QUILTER_PLUGINS_TYPE_PLUGIN_MANAGER))
#define QUILTER_PLUGINS_PLUGIN_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), QUILTER_PLUGINS_TYPE_PLUGIN_MANAGER, QuilterPluginsPluginManagerClass))

typedef struct _QuilterPluginsPluginManager QuilterPluginsPluginManager;
typedef struct _QuilterPluginsPluginManagerClass QuilterPluginsPluginManagerClass;

#define QUILTER_PLUGINS_TYPE_PLUGIN (quilter_plugins_plugin_get_type ())
#define QUILTER_PLUGINS_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), QUILTER_PLUGINS_TYPE_PLUGIN, QuilterPluginsPlugin))
#define QUILTER_PLUGINS_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), QUILTER_PLUGINS_TYPE_PLUGIN, QuilterPluginsPluginClass))
#define QUILTER_PLUGINS_IS_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), QUILTER_PLUGINS_TYPE_PLUGIN))
#define QUILTER_PLUGINS_IS_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), QUILTER_PLUGINS_TYPE_PLUGIN))
#define QUILTER_PLUGINS_PLUGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), QUILTER_PLUGINS_TYPE_PLUGIN, QuilterPluginsPluginClass))

typedef struct _QuilterPluginsPlugin QuilterPluginsPlugin;
typedef struct _QuilterPluginsPluginClass QuilterPluginsPluginClass;

struct _QuilterWidgetsPreview {
	WebKitWebView parent_instance;
	QuilterWidgetsPreviewPrivate * priv;
	QuilterWidgetsEditView* buf;
	gchar* html;
};

struct _QuilterWidgetsPreviewClass {
	WebKitWebViewClass parent_class;
};

struct _QuilterMainWindow {
	HdyApplicationWindow parent_instance;
	QuilterMainWindowPrivate * priv;
	GtkAdjustment* eadj;
	GtkBox* box;
	GtkBox* main_leaf;
	GtkOverlay* overlay_editor;
	GtkButton* focus_overlay_button;
	HdyLeaflet* grid;
	HdyLeaflet* header;
	HdyTitleBar* window_header;
	HdyHeaderBar* welcome_titlebar;
	GtkGrid* main_pane;
	GtkGrid* welcome_view;
	GtkMenuButton* set_font_menu;
	GtkPaned* paned;
	GtkRevealer* titlebar_revealer;
	GtkRevealer* overlay_button_revealer;
	GtkScrolledWindow* edit_view;
	GtkStack* main_stack;
	GtkStack* stack;
	GtkStack* titlebar_stack;
	GtkStack* win_stack;
	GtkSeparator* separator;
	GtkSeparator* separator2;
	GtkOverlay* overlay_statusbar;
	QuilterWidgetsEditView* edit_view_content;
	QuilterWidgetsHeaderbar* titlebar;
	QuilterWidgetsPreview* preview_view_content;
	QuilterWidgetsSearchBar* searchbar;
	QuilterWidgetsStatusBar* statusbar;
	QuilterWidgetsSideBar* sidebar;
};

struct _QuilterMainWindowClass {
	HdyApplicationWindowClass parent_class;
};

static gpointer quilter_widgets_preview_parent_class = NULL;
static QuilterWidgetsPreview* quilter_widgets_preview_instance;
static QuilterWidgetsPreview* quilter_widgets_preview_instance = NULL;
VALA_EXTERN QuilterMainWindow* quilter_application_win;
VALA_EXTERN GSettings* quilter_application_gsettings;

VALA_EXTERN GType quilter_widgets_preview_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (QuilterWidgetsPreview, g_object_unref)
VALA_EXTERN GType quilter_widgets_edit_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (QuilterWidgetsEditView, g_object_unref)
VALA_EXTERN QuilterWidgetsPreview* quilter_widgets_preview_get_instance (void);
VALA_EXTERN GType quilter_main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (QuilterMainWindow, g_object_unref)
VALA_EXTERN GType quilter_widgets_headerbar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (QuilterWidgetsHeaderbar, g_object_unref)
VALA_EXTERN GType quilter_widgets_search_bar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (QuilterWidgetsSearchBar, g_object_unref)
VALA_EXTERN GType quilter_widgets_status_bar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (QuilterWidgetsStatusBar, g_object_unref)
VALA_EXTERN GType quilter_widgets_side_bar_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (QuilterWidgetsSideBar, g_object_unref)
VALA_EXTERN QuilterWidgetsPreview* quilter_widgets_preview_new (QuilterMainWindow* window,
                                                    QuilterWidgetsEditView* buf);
VALA_EXTERN QuilterWidgetsPreview* quilter_widgets_preview_construct (GType object_type,
                                                          QuilterMainWindow* window,
                                                          QuilterWidgetsEditView* buf);
VALA_EXTERN void quilter_widgets_preview_set_scroll_value (QuilterWidgetsPreview* self,
                                               gdouble value);
VALA_EXTERN void quilter_widgets_preview_update_html_view (QuilterWidgetsPreview* self);
static void quilter_widgets_preview_connect_signals (QuilterWidgetsPreview* self);
static gboolean quilter_widgets_preview_real_context_menu (WebKitWebView* base,
                                                    WebKitContextMenu* context_menu,
                                                    GdkEvent* event,
                                                    WebKitHitTestResult* hit_test_result);
static gchar* quilter_widgets_preview_set_stylesheet (QuilterWidgetsPreview* self);
static gchar* quilter_widgets_preview_set_font_stylesheet (QuilterWidgetsPreview* self);
static gchar* quilter_widgets_preview_set_highlight_stylesheet (QuilterWidgetsPreview* self);
static gchar* quilter_widgets_preview_set_highlight (QuilterWidgetsPreview* self);
static gchar* quilter_widgets_preview_set_center_headers (QuilterWidgetsPreview* self);
static gchar* quilter_widgets_preview_set_latex (QuilterWidgetsPreview* self);
static gchar* quilter_widgets_preview_set_mermaid (QuilterWidgetsPreview* self);
static gboolean __lambda15_ (QuilterWidgetsPreview* self,
                      WebKitPolicyDecision* decision,
                      WebKitPolicyDecisionType type);
static void quilter_widgets_preview_launch_browser (QuilterWidgetsPreview* self,
                                             const gchar* url);
static gboolean ___lambda15__webkit_web_view_decide_policy (WebKitWebView* _sender,
                                                     WebKitPolicyDecision* decision,
                                                     WebKitPolicyDecisionType type,
                                                     gpointer self);
static void __lambda16_ (QuilterWidgetsPreview* self,
                  WebKitLoadEvent event);
static void ___lambda16__webkit_web_view_load_changed (WebKitWebView* _sender,
                                                WebKitLoadEvent load_event,
                                                gpointer self);
VALA_EXTERN gchar* quilter_services_file_manager_get_yamlless_markdown (const gchar* markdown,
                                                            gint lines,
                                                            gchar** title,
                                                            gchar** date,
                                                            gboolean non_empty,
                                                            gboolean include_title,
                                                            gboolean include_date);
VALA_EXTERN gchar* quilter_widgets_edit_view_get_text (QuilterWidgetsEditView* self);
static gchar* quilter_widgets_preview_process_plugins (QuilterWidgetsPreview* self,
                                                const gchar* raw_mk);
VALA_EXTERN GType quilter_plugins_plugin_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (QuilterPluginsPluginManager, g_object_unref)
VALA_EXTERN QuilterPluginsPluginManager* quilter_plugins_plugin_manager_get_instance (void);
VALA_EXTERN GType quilter_plugins_plugin_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (QuilterPluginsPlugin, g_object_unref)
VALA_EXTERN GList* quilter_plugins_plugin_manager_get_plugs (QuilterPluginsPluginManager* self);
VALA_EXTERN gboolean quilter_plugins_plugin_has_match (QuilterPluginsPlugin* self,
                                           const gchar* text);
VALA_EXTERN gchar* quilter_plugins_plugin_convert (QuilterPluginsPlugin* self,
                                       const gchar* line);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void quilter_widgets_preview_finalize (GObject * obj);
static GType quilter_widgets_preview_get_type_once (void);
static void _vala_quilter_widgets_preview_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

QuilterWidgetsPreview*
quilter_widgets_preview_get_instance (void)
{
	QuilterWidgetsPreview* _tmp0_;
	QuilterWidgetsPreview* _tmp5_;
	QuilterWidgetsPreview* _tmp6_;
	QuilterWidgetsPreview* result = NULL;
	_tmp0_ = quilter_widgets_preview_instance;
	if (_tmp0_ == NULL) {
		QuilterMainWindow* _tmp1_;
		QuilterMainWindow* _tmp2_;
		QuilterWidgetsEditView* _tmp3_;
		QuilterWidgetsPreview* _tmp4_;
		_tmp1_ = quilter_application_win;
		_tmp2_ = quilter_application_win;
		_tmp3_ = _tmp2_->edit_view_content;
		_tmp4_ = quilter_widgets_preview_new (_tmp1_, _tmp3_);
		g_object_ref_sink (_tmp4_);
		_g_object_unref0 (quilter_widgets_preview_instance);
		quilter_widgets_preview_instance = _tmp4_;
	}
	_tmp5_ = quilter_widgets_preview_instance;
	_tmp6_ = _g_object_ref0 (_tmp5_);
	result = _tmp6_;
	return result;
}

QuilterWidgetsPreview*
quilter_widgets_preview_construct (GType object_type,
                                   QuilterMainWindow* window,
                                   QuilterWidgetsEditView* buf)
{
	QuilterWidgetsPreview * self = NULL;
	WebKitUserContentManager* _tmp0_;
	WebKitUserContentManager* _tmp1_;
	QuilterWidgetsEditView* _tmp2_;
	WebKitSettings* webkit_settings = NULL;
	WebKitSettings* _tmp3_;
	WebKitSettings* _tmp4_;
	g_return_val_if_fail (window != NULL, NULL);
	g_return_val_if_fail (buf != NULL, NULL);
	_tmp0_ = webkit_user_content_manager_new ();
	_tmp1_ = _tmp0_;
	self = (QuilterWidgetsPreview*) g_object_new (object_type, "user-content-manager", _tmp1_, NULL);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = _g_object_ref0 (buf);
	_g_object_unref0 (self->buf);
	self->buf = _tmp2_;
	_tmp3_ = webkit_web_view_get_settings ((WebKitWebView*) self);
	_tmp4_ = _g_object_ref0 (_tmp3_);
	webkit_settings = _tmp4_;
	webkit_settings_set_enable_page_cache (webkit_settings, FALSE);
	webkit_settings_set_javascript_can_open_windows_automatically (webkit_settings, FALSE);
	webkit_settings_set_enable_java (webkit_settings, FALSE);
	quilter_widgets_preview_set_scroll_value (self, (gdouble) -1);
	quilter_widgets_preview_update_html_view (self);
	quilter_widgets_preview_connect_signals (self);
	_g_object_unref0 (webkit_settings);
	return self;
}

QuilterWidgetsPreview*
quilter_widgets_preview_new (QuilterMainWindow* window,
                             QuilterWidgetsEditView* buf)
{
	return quilter_widgets_preview_construct (QUILTER_WIDGETS_TYPE_PREVIEW, window, buf);
}

static gboolean
quilter_widgets_preview_real_context_menu (WebKitWebView* base,
                                           WebKitContextMenu* context_menu,
                                           GdkEvent* event,
                                           WebKitHitTestResult* hit_test_result)
{
	QuilterWidgetsPreview * self;
	gboolean result = FALSE;
	self = (QuilterWidgetsPreview*) base;
	g_return_val_if_fail (context_menu != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	g_return_val_if_fail (hit_test_result != NULL, FALSE);
	result = TRUE;
	return result;
}

static gchar*
quilter_widgets_preview_set_stylesheet (QuilterWidgetsPreview* self)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	gchar* _tmp15_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = quilter_application_gsettings;
	_tmp1_ = g_settings_get_string (_tmp0_, "visual-mode");
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strcmp0 (_tmp2_, "dark") == 0;
	_g_free0 (_tmp2_);
	if (_tmp3_) {
		gchar* dark = NULL;
		gchar* _tmp4_;
		_tmp4_ = g_strdup (QUILTER_STYLES_QUILTERDARK_css);
		dark = _tmp4_;
		result = dark;
		return result;
	} else {
		GSettings* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gboolean _tmp8_;
		_tmp5_ = quilter_application_gsettings;
		_tmp6_ = g_settings_get_string (_tmp5_, "visual-mode");
		_tmp7_ = _tmp6_;
		_tmp8_ = g_strcmp0 (_tmp7_, "sepia") == 0;
		_g_free0 (_tmp7_);
		if (_tmp8_) {
			gchar* sepia = NULL;
			gchar* _tmp9_;
			_tmp9_ = g_strdup (QUILTER_STYLES_QUILTERSEPIA_css);
			sepia = _tmp9_;
			result = sepia;
			return result;
		} else {
			GSettings* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gboolean _tmp13_;
			_tmp10_ = quilter_application_gsettings;
			_tmp11_ = g_settings_get_string (_tmp10_, "visual-mode");
			_tmp12_ = _tmp11_;
			_tmp13_ = g_strcmp0 (_tmp12_, "light") == 0;
			_g_free0 (_tmp12_);
			if (_tmp13_) {
				gchar* normal = NULL;
				gchar* _tmp14_;
				_tmp14_ = g_strdup (QUILTER_STYLES_QUILTER_css);
				normal = _tmp14_;
				result = normal;
				return result;
			}
		}
	}
	_tmp15_ = g_strdup ("");
	result = _tmp15_;
	return result;
}

static gchar*
quilter_widgets_preview_set_font_stylesheet (QuilterWidgetsPreview* self)
{
	GSettings* _tmp0_;
	gchar** _tmp15_;
	gchar** _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = quilter_application_gsettings;
	if (g_settings_get_enum (_tmp0_, "preview-font") == 0) {
		gchar** _tmp1_;
		gchar** _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp2_ = _tmp1_ = g_get_system_data_dirs ();
		_tmp3_ = _tmp2_[0];
		_tmp4_ = g_strconcat (_tmp3_, "/io.github.lainsce.Quilter/font/serif.css", NULL);
		result = _tmp4_;
		return result;
	} else {
		GSettings* _tmp5_;
		_tmp5_ = quilter_application_gsettings;
		if (g_settings_get_enum (_tmp5_, "preview-font") == 1) {
			gchar** _tmp6_;
			gchar** _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			_tmp7_ = _tmp6_ = g_get_system_data_dirs ();
			_tmp8_ = _tmp7_[0];
			_tmp9_ = g_strconcat (_tmp8_, "/io.github.lainsce.Quilter/font/sans.css", NULL);
			result = _tmp9_;
			return result;
		} else {
			GSettings* _tmp10_;
			_tmp10_ = quilter_application_gsettings;
			if (g_settings_get_enum (_tmp10_, "preview-font") == 2) {
				gchar** _tmp11_;
				gchar** _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
				_tmp12_ = _tmp11_ = g_get_system_data_dirs ();
				_tmp13_ = _tmp12_[0];
				_tmp14_ = g_strconcat (_tmp13_, "/io.github.lainsce.Quilter/font/mono.css", NULL);
				result = _tmp14_;
				return result;
			}
		}
	}
	_tmp16_ = _tmp15_ = g_get_system_data_dirs ();
	_tmp17_ = _tmp16_[0];
	_tmp18_ = g_strconcat (_tmp17_, "/io.github.lainsce.Quilter/font/serif.css", NULL);
	result = _tmp18_;
	return result;
}

static gchar*
quilter_widgets_preview_set_highlight_stylesheet (QuilterWidgetsPreview* self)
{
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = quilter_application_gsettings;
	_tmp1_ = g_settings_get_string (_tmp0_, "visual-mode");
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strcmp0 (_tmp2_, "dark") == 0;
	_g_free0 (_tmp2_);
	if (_tmp3_) {
		gchar** _tmp4_;
		gchar** _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		_tmp5_ = _tmp4_ = g_get_system_data_dirs ();
		_tmp6_ = _tmp5_[0];
		_tmp7_ = g_strconcat (_tmp6_, "/io.github.lainsce.Quilter/highlight.js/styles/dark.min.css", NULL);
		result = _tmp7_;
		return result;
	} else {
		GSettings* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gboolean _tmp11_;
		_tmp8_ = quilter_application_gsettings;
		_tmp9_ = g_settings_get_string (_tmp8_, "visual-mode");
		_tmp10_ = _tmp9_;
		_tmp11_ = g_strcmp0 (_tmp10_, "sepia") == 0;
		_g_free0 (_tmp10_);
		if (_tmp11_) {
			gchar** _tmp12_;
			gchar** _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			_tmp13_ = _tmp12_ = g_get_system_data_dirs ();
			_tmp14_ = _tmp13_[0];
			_tmp15_ = g_strconcat (_tmp14_, "/io.github.lainsce.Quilter/highlight.js/styles/sepia.min.css", NULL);
			result = _tmp15_;
			return result;
		} else {
			GSettings* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gboolean _tmp19_;
			_tmp16_ = quilter_application_gsettings;
			_tmp17_ = g_settings_get_string (_tmp16_, "visual-mode");
			_tmp18_ = _tmp17_;
			_tmp19_ = g_strcmp0 (_tmp18_, "light") == 0;
			_g_free0 (_tmp18_);
			if (_tmp19_) {
				gchar** _tmp20_;
				gchar** _tmp21_;
				const gchar* _tmp22_;
				gchar* _tmp23_;
				_tmp21_ = _tmp20_ = g_get_system_data_dirs ();
				_tmp22_ = _tmp21_[0];
				_tmp23_ = g_strconcat (_tmp22_, "/io.github.lainsce.Quilter/highlight.js/styles/default.min.css", NULL);
				result = _tmp23_;
				return result;
			} else {
				gchar* _tmp24_;
				_tmp24_ = g_strdup ("");
				result = _tmp24_;
				return result;
			}
		}
	}
}

static gchar*
quilter_widgets_preview_set_highlight (QuilterWidgetsPreview* self)
{
	GSettings* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = quilter_application_gsettings;
	if (g_settings_get_boolean (_tmp0_, "highlight")) {
		gchar* render = NULL;
		gchar** _tmp1_;
		gchar** _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* hl = NULL;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		_tmp2_ = _tmp1_ = g_get_system_data_dirs ();
		_tmp3_ = _tmp2_[0];
		_tmp4_ = g_strconcat (_tmp3_, "/io.github.lainsce.Quilter/highlight.js/lib/highlight.min.js", NULL);
		render = _tmp4_;
		_tmp5_ = quilter_widgets_preview_set_highlight_stylesheet (self);
		_tmp6_ = _tmp5_;
		_tmp7_ = render;
		_tmp8_ = g_strdup_printf ("\n" \
"                    <link rel=\"stylesheet\" href=\"%s\">\n" \
"                    <script defer src=\"%s\" onload=\"hljs.initHighlig" \
"htingOnLoad();\"></script>\n" \
"                ", _tmp6_, _tmp7_);
		_tmp9_ = _tmp8_;
		_g_free0 (_tmp6_);
		hl = _tmp9_;
		result = hl;
		_g_free0 (render);
		return result;
	} else {
		gchar* _tmp10_;
		_tmp10_ = g_strdup ("");
		result = _tmp10_;
		return result;
	}
}

static gchar*
quilter_widgets_preview_set_center_headers (QuilterWidgetsPreview* self)
{
	GSettings* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = quilter_application_gsettings;
	if (g_settings_get_boolean (_tmp0_, "center-headers")) {
		gchar** _tmp1_;
		gchar** _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp2_ = _tmp1_ = g_get_system_data_dirs ();
		_tmp3_ = _tmp2_[0];
		_tmp4_ = g_strconcat (_tmp3_, "/io.github.lainsce.Quilter/center_headers/cheaders.css", NULL);
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_;
		_tmp5_ = g_strdup ("");
		result = _tmp5_;
		return result;
	}
}

static gchar*
quilter_widgets_preview_set_latex (QuilterWidgetsPreview* self)
{
	GSettings* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = quilter_application_gsettings;
	if (g_settings_get_boolean (_tmp0_, "latex")) {
		gchar* katex_main = NULL;
		gchar** _tmp1_;
		gchar** _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* katex_js = NULL;
		gchar** _tmp5_;
		gchar** _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* render = NULL;
		gchar** _tmp9_;
		gchar** _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* latex = NULL;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		_tmp2_ = _tmp1_ = g_get_system_data_dirs ();
		_tmp3_ = _tmp2_[0];
		_tmp4_ = g_strconcat (_tmp3_, "/io.github.lainsce.Quilter/katex/katex.css", NULL);
		katex_main = _tmp4_;
		_tmp6_ = _tmp5_ = g_get_system_data_dirs ();
		_tmp7_ = _tmp6_[0];
		_tmp8_ = g_strconcat (_tmp7_, "/io.github.lainsce.Quilter/katex/katex.js", NULL);
		katex_js = _tmp8_;
		_tmp10_ = _tmp9_ = g_get_system_data_dirs ();
		_tmp11_ = _tmp10_[0];
		_tmp12_ = g_strconcat (_tmp11_, "/io.github.lainsce.Quilter/katex/render.js", NULL);
		render = _tmp12_;
		_tmp13_ = katex_main;
		_tmp14_ = katex_js;
		_tmp15_ = render;
		_tmp16_ = g_strdup_printf ("\n" \
"                    <link rel=\"stylesheet\" href=\"%s\">\n" \
"                    <script defer src=\"%s\"></script>\n" \
"                    <script defer src=\"%s\" onload=\"renderMathInElem" \
"ent(document.body);\"></script>\n" \
"                ", _tmp13_, _tmp14_, _tmp15_);
		latex = _tmp16_;
		result = latex;
		_g_free0 (render);
		_g_free0 (katex_js);
		_g_free0 (katex_main);
		return result;
	} else {
		gchar* _tmp17_;
		_tmp17_ = g_strdup ("");
		result = _tmp17_;
		return result;
	}
}

static gchar*
quilter_widgets_preview_set_mermaid (QuilterWidgetsPreview* self)
{
	GSettings* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = quilter_application_gsettings;
	if (g_settings_get_boolean (_tmp0_, "mermaid")) {
		gchar* render = NULL;
		gchar** _tmp1_;
		gchar** _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* mermaid = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp2_ = _tmp1_ = g_get_system_data_dirs ();
		_tmp3_ = _tmp2_[0];
		_tmp4_ = g_strconcat (_tmp3_, "/io.github.lainsce.Quilter/mermaid/mermaid.js", NULL);
		render = _tmp4_;
		_tmp5_ = render;
		_tmp6_ = g_strdup_printf ("\n" \
"                    <script src=\"%s\"></script>\n" \
"                    <script>\n" \
"                        var config = {\n" \
"                            startOnLoad: true,\n" \
"                            pie:{\n" \
"                                    useMaxWidth:false,\n" \
"                                    htmlLabels:true\n" \
"                            }\n" \
"                        };\n" \
"                        mermaid.initialize(config);\n" \
"                        mermaid.init(undefined, document.querySelector" \
"All('.language-mermaid'));\n" \
"                    </script>\n" \
"                ", _tmp5_);
		mermaid = _tmp6_;
		result = mermaid;
		_g_free0 (render);
		return result;
	} else {
		gchar* _tmp7_;
		_tmp7_ = g_strdup ("");
		result = _tmp7_;
		return result;
	}
}

static gboolean
__lambda15_ (QuilterWidgetsPreview* self,
             WebKitPolicyDecision* decision,
             WebKitPolicyDecisionType type)
{
	gboolean result = FALSE;
	g_return_val_if_fail (decision != NULL, FALSE);
	switch (type) {
		case WEBKIT_POLICY_DECISION_TYPE_NEW_WINDOW_ACTION:
		{
			if (G_TYPE_CHECK_INSTANCE_TYPE (decision, webkit_response_policy_decision_get_type ())) {
				WebKitResponsePolicyDecision* policy = NULL;
				WebKitResponsePolicyDecision* _tmp0_;
				WebKitResponsePolicyDecision* _tmp1_;
				WebKitURIRequest* _tmp2_;
				WebKitURIRequest* _tmp3_;
				const gchar* _tmp4_;
				_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (decision, webkit_response_policy_decision_get_type (), WebKitResponsePolicyDecision));
				policy = _tmp0_;
				_tmp1_ = policy;
				_tmp2_ = webkit_response_policy_decision_get_request (_tmp1_);
				_tmp3_ = _tmp2_;
				_tmp4_ = webkit_uri_request_get_uri (_tmp3_);
				quilter_widgets_preview_launch_browser (self, _tmp4_);
				_g_object_unref0 (policy);
			}
			break;
		}
		case WEBKIT_POLICY_DECISION_TYPE_RESPONSE:
		{
			if (G_TYPE_CHECK_INSTANCE_TYPE (decision, webkit_response_policy_decision_get_type ())) {
				WebKitResponsePolicyDecision* policy = NULL;
				WebKitResponsePolicyDecision* _tmp5_;
				WebKitResponsePolicyDecision* _tmp6_;
				WebKitURIRequest* _tmp7_;
				WebKitURIRequest* _tmp8_;
				const gchar* _tmp9_;
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (decision, webkit_response_policy_decision_get_type (), WebKitResponsePolicyDecision));
				policy = _tmp5_;
				_tmp6_ = policy;
				_tmp7_ = webkit_response_policy_decision_get_request (_tmp6_);
				_tmp8_ = _tmp7_;
				_tmp9_ = webkit_uri_request_get_uri (_tmp8_);
				quilter_widgets_preview_launch_browser (self, _tmp9_);
				result = FALSE;
				_g_object_unref0 (policy);
				return result;
			}
			break;
		}
		case WEBKIT_POLICY_DECISION_TYPE_NAVIGATION_ACTION:
		{
			break;
		}
		default:
		break;
	}
	result = TRUE;
	return result;
}

static gboolean
___lambda15__webkit_web_view_decide_policy (WebKitWebView* _sender,
                                            WebKitPolicyDecision* decision,
                                            WebKitPolicyDecisionType type,
                                            gpointer self)
{
	gboolean result;
	result = __lambda15_ ((QuilterWidgetsPreview*) self, decision, type);
	return result;
}

static void
__lambda16_ (QuilterWidgetsPreview* self,
             WebKitLoadEvent event)
{
	if (event == WEBKIT_LOAD_FINISHED) {
		GdkRectangle rectangle = {0};
		WebKitWindowProperties* _tmp0_;
		GdkRectangle _tmp1_ = {0};
		GdkRectangle _tmp2_;
		GdkRectangle _tmp3_;
		_tmp0_ = webkit_web_view_get_window_properties ((WebKitWebView*) self);
		webkit_window_properties_get_geometry (_tmp0_, &_tmp1_);
		rectangle = _tmp1_;
		_tmp2_ = rectangle;
		_tmp3_ = rectangle;
		gtk_widget_set_size_request ((GtkWidget*) self, _tmp2_.width, _tmp3_.height);
	}
}

static void
___lambda16__webkit_web_view_load_changed (WebKitWebView* _sender,
                                           WebKitLoadEvent load_event,
                                           gpointer self)
{
	__lambda16_ ((QuilterWidgetsPreview*) self, load_event);
}

static void
quilter_widgets_preview_connect_signals (QuilterWidgetsPreview* self)
{
	g_return_if_fail (self != NULL);
	g_signal_connect_object ((WebKitWebView*) self, "decide-policy", (GCallback) ___lambda15__webkit_web_view_decide_policy, self, 0);
	g_signal_connect_object ((WebKitWebView*) self, "load-changed", (GCallback) ___lambda16__webkit_web_view_load_changed, self, 0);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static void
quilter_widgets_preview_launch_browser (QuilterWidgetsPreview* self,
                                        const gchar* url)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (url != NULL);
	if (!string_contains (url, "/embed/")) {
		{
			g_app_info_launch_default_for_uri (url, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp0_;
			const gchar* _tmp1_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp0_ = e;
			_tmp1_ = _tmp0_->message;
			g_warning ("WebView.vala:207: No app to handle urls: %s", _tmp1_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		webkit_web_view_stop_loading ((WebKitWebView*) self);
	}
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	g_return_val_if_fail (self != NULL, NULL);
	res = (guint8*) self;
	res_length1 = -1;
	_res_size_ = res_length1;
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	res_length1 = (gint) _tmp1_;
	_tmp2_ = res;
	_tmp2__length1 = res_length1;
	if (result_length1) {
		*result_length1 = _tmp2__length1;
	}
	result = _tmp2_;
	return result;
}

void
quilter_widgets_preview_update_html_view (QuilterWidgetsPreview* self)
{
	gchar* processed_mk = NULL;
	gchar* title = NULL;
	gchar* date = NULL;
	QuilterWidgetsEditView* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
	MMIOT* mkd = NULL;
	const gchar* _tmp7_;
	guint8* _tmp8_;
	gint _tmp8__length1;
	gint _tmp9_ = 0;
	guint8* _tmp10_;
	gint _tmp10__length1;
	MMIOT* _tmp11_;
	MMIOT* _tmp12_;
	MMIOT* _tmp13_;
	const gchar* _tmp14_ = NULL;
	gchar* _tmp15_;
	gchar* highlight = NULL;
	gchar* _tmp16_;
	gchar* cheaders = NULL;
	gchar* _tmp17_;
	gchar* latex = NULL;
	gchar* _tmp18_;
	gchar* mermaid = NULL;
	gchar* _tmp19_;
	gchar* font = NULL;
	gchar* _tmp20_;
	gchar* style = NULL;
	gchar* _tmp21_;
	gchar* md = NULL;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gboolean focus_active = FALSE;
	GSettings* _tmp24_;
	gboolean typewriter_active = FALSE;
	GSettings* _tmp25_;
	gboolean _tmp26_ = FALSE;
	const gchar* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	gchar* _tmp38_;
	const gchar* _tmp39_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->buf;
	_tmp1_ = quilter_widgets_edit_view_get_text (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp6_ = quilter_services_file_manager_get_yamlless_markdown (_tmp3_, 0, &_tmp4_, &_tmp5_, TRUE, TRUE, FALSE);
	_g_free0 (title);
	title = _tmp4_;
	_g_free0 (date);
	date = _tmp5_;
	_g_free0 (processed_mk);
	processed_mk = _tmp6_;
	_g_free0 (_tmp3_);
	_tmp7_ = processed_mk;
	_tmp8_ = string_get_data (_tmp7_, &_tmp9_);
	_tmp8__length1 = _tmp9_;
	_tmp10_ = _tmp8_;
	_tmp10__length1 = _tmp8__length1;
	_tmp11_ = gfm_string (_tmp10_, _tmp10__length1, ((((((((MKD_TOC + MKD_AUTOLINK) + MKD_EXTRA_FOOTNOTE) + MKD_DLEXTRA) + MKD_FENCEDCODE) + MKD_GITHUBTAGS) + MKD_LATEX) + MKD_URLENCODEDANCHOR) + MKD_NOSTYLE) + MKD_EXPLICITLIST);
	mkd = _tmp11_;
	_tmp12_ = mkd;
	mkd_compile (_tmp12_, ((((((((MKD_TOC + MKD_AUTOLINK) + MKD_EXTRA_FOOTNOTE) + MKD_DLEXTRA) + MKD_FENCEDCODE) + MKD_GITHUBTAGS) + MKD_LATEX) + MKD_URLENCODEDANCHOR) + MKD_NOSTYLE) + MKD_EXPLICITLIST);
	_tmp13_ = mkd;
	mkd_document (_tmp13_, &_tmp14_);
	_g_free0 (processed_mk);
	_tmp15_ = g_strdup (_tmp14_);
	processed_mk = _tmp15_;
	_tmp16_ = quilter_widgets_preview_set_highlight (self);
	highlight = _tmp16_;
	_tmp17_ = quilter_widgets_preview_set_center_headers (self);
	cheaders = _tmp17_;
	_tmp18_ = quilter_widgets_preview_set_latex (self);
	latex = _tmp18_;
	_tmp19_ = quilter_widgets_preview_set_mermaid (self);
	mermaid = _tmp19_;
	_tmp20_ = quilter_widgets_preview_set_font_stylesheet (self);
	font = _tmp20_;
	_tmp21_ = quilter_widgets_preview_set_stylesheet (self);
	style = _tmp21_;
	_tmp22_ = processed_mk;
	_tmp23_ = quilter_widgets_preview_process_plugins (self, _tmp22_);
	md = _tmp23_;
	_tmp24_ = quilter_application_gsettings;
	focus_active = g_settings_get_boolean (_tmp24_, "focus-mode");
	_tmp25_ = quilter_application_gsettings;
	typewriter_active = g_settings_get_boolean (_tmp25_, "typewriter-scrolling");
	if (focus_active) {
		_tmp26_ = typewriter_active;
	} else {
		_tmp26_ = FALSE;
	}
	if (_tmp26_) {
		const gchar* _tmp27_;
		gchar* _tmp28_;
		_tmp27_ = style;
		_tmp28_ = g_strconcat (_tmp27_, "\n" \
"                html {\n" \
"                    padding-top: 50%;\n" \
"                    padding-bottom: 50%;\n" \
"                }\n" \
"                ", NULL);
		_g_free0 (style);
		style = _tmp28_;
	} else {
		const gchar* _tmp29_;
		gchar* _tmp30_;
		_tmp29_ = style;
		_tmp30_ = g_strconcat (_tmp29_, "\n" \
"                html {\n" \
"                    padding-bottom: 10%;\n" \
"                }\n" \
"                ", NULL);
		_g_free0 (style);
		style = _tmp30_;
	}
	_tmp31_ = style;
	_tmp32_ = highlight;
	_tmp33_ = latex;
	_tmp34_ = font;
	_tmp35_ = cheaders;
	_tmp36_ = mermaid;
	_tmp37_ = md;
	_tmp38_ = g_strdup_printf ("\n" \
"            <!doctype html>\n" \
"            <html>\n" \
"                <head>\n" \
"                    <meta charset=\"utf-8\">\n" \
"                    <style>%s</style>\n" \
"                    %s\n" \
"                    %s\n" \
"                    <link rel=\"stylesheet\" href=\"%s\"/>\n" \
"                    <link rel=\"stylesheet\" href=\"%s\"/>\n" \
"                </head>\n" \
"                <body>\n" \
"                    %s\n" \
"                    <div class=\"markdown-body\">\n" \
"                        %s\n" \
"                    </div>\n" \
"                </body>\n" \
"            </html>", _tmp31_, _tmp32_, _tmp33_, _tmp34_, _tmp35_, _tmp36_, _tmp37_);
	_g_free0 (self->html);
	self->html = _tmp38_;
	_tmp39_ = self->html;
	webkit_web_view_load_html ((WebKitWebView*) self, _tmp39_, "file:///");
	_g_free0 (md);
	_g_free0 (style);
	_g_free0 (font);
	_g_free0 (mermaid);
	_g_free0 (latex);
	_g_free0 (cheaders);
	_g_free0 (highlight);
	_mkd_cleanup0 (mkd);
	_g_free0 (date);
	_g_free0 (title);
	_g_free0 (processed_mk);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static gchar*
quilter_widgets_preview_process_plugins (QuilterWidgetsPreview* self,
                                         const gchar* raw_mk)
{
	gchar** lines = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint lines_length1;
	gint _lines_size_;
	gchar* build = NULL;
	gchar* _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (raw_mk != NULL, NULL);
	_tmp1_ = _tmp0_ = g_strsplit (raw_mk, "\n", 0);
	lines = _tmp1_;
	lines_length1 = _vala_array_length (_tmp0_);
	_lines_size_ = lines_length1;
	_tmp2_ = g_strdup ("");
	build = _tmp2_;
	_tmp3_ = lines;
	_tmp3__length1 = lines_length1;
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
		line_collection = _tmp3_;
		line_collection_length1 = _tmp3__length1;
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
			gchar* _tmp4_;
			gchar* line = NULL;
			_tmp4_ = g_strdup (line_collection[line_it]);
			line = _tmp4_;
			{
				gboolean found = FALSE;
				QuilterPluginsPluginManager* _tmp5_;
				QuilterPluginsPluginManager* _tmp6_;
				GList* _tmp7_;
				GList* _tmp8_;
				found = FALSE;
				_tmp5_ = quilter_plugins_plugin_manager_get_instance ();
				_tmp6_ = _tmp5_;
				_tmp7_ = quilter_plugins_plugin_manager_get_plugs (_tmp6_);
				_tmp8_ = _tmp7_;
				_g_object_unref0 (_tmp6_);
				{
					GList* plugin_collection = NULL;
					GList* plugin_it = NULL;
					plugin_collection = _tmp8_;
					for (plugin_it = plugin_collection; plugin_it != NULL; plugin_it = plugin_it->next) {
						QuilterPluginsPlugin* _tmp9_;
						QuilterPluginsPlugin* plugin = NULL;
						_tmp9_ = _g_object_ref0 ((QuilterPluginsPlugin*) plugin_it->data);
						plugin = _tmp9_;
						{
							QuilterPluginsPlugin* _tmp10_;
							const gchar* _tmp11_;
							_tmp10_ = plugin;
							_tmp11_ = line;
							if (quilter_plugins_plugin_has_match (_tmp10_, _tmp11_)) {
								const gchar* _tmp12_;
								QuilterPluginsPlugin* _tmp13_;
								const gchar* _tmp14_;
								gchar* _tmp15_;
								gchar* _tmp16_;
								gchar* _tmp17_;
								gchar* _tmp18_;
								gchar* _tmp19_;
								_tmp12_ = build;
								_tmp13_ = plugin;
								_tmp14_ = line;
								_tmp15_ = quilter_plugins_plugin_convert (_tmp13_, _tmp14_);
								_tmp16_ = _tmp15_;
								_tmp17_ = g_strconcat (_tmp12_, _tmp16_, NULL);
								_tmp18_ = _tmp17_;
								_tmp19_ = g_strconcat (_tmp18_, "\n", NULL);
								_g_free0 (build);
								build = _tmp19_;
								_g_free0 (_tmp18_);
								_g_free0 (_tmp16_);
								found = TRUE;
								_g_object_unref0 (plugin);
								break;
							}
							_g_object_unref0 (plugin);
						}
					}
					(plugin_collection == NULL) ? NULL : (plugin_collection = (_g_list_free__g_object_unref0_ (plugin_collection), NULL));
				}
				if (!found) {
					const gchar* _tmp20_;
					const gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					gchar* _tmp24_;
					_tmp20_ = build;
					_tmp21_ = line;
					_tmp22_ = g_strconcat (_tmp20_, _tmp21_, NULL);
					_tmp23_ = _tmp22_;
					_tmp24_ = g_strconcat (_tmp23_, "\n", NULL);
					_g_free0 (build);
					build = _tmp24_;
					_g_free0 (_tmp23_);
				}
				_g_free0 (line);
			}
		}
	}
	result = build;
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

void
quilter_widgets_preview_set_scroll_value (QuilterWidgetsPreview* self,
                                          gdouble value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup_printf ("\n" \
"                    var b = document.body,\n" \
"                    e = document.documentElement;\n" \
"                    var height = Math.max( b.scrollHeight,\n" \
"                                           b.offsetHeight,\n" \
"                                           e.clientHeight,\n" \
"                                           e.scrollHeight,\n" \
"                                           e.offsetHeight\n" \
"                                 );\n" \
"                    e.scrollTop = (%.13f * e.offsetHeight);\n" \
"                    e.scrollTop;\n" \
"                ", value);
	_tmp1_ = _tmp0_;
	webkit_web_view_run_javascript ((WebKitWebView*) self, _tmp1_, NULL, NULL, NULL);
	_g_free0 (_tmp1_);
	g_object_notify_by_pspec ((GObject *) self, quilter_widgets_preview_properties[QUILTER_WIDGETS_PREVIEW_SCROLL_VALUE_PROPERTY]);
}

static void
quilter_widgets_preview_class_init (QuilterWidgetsPreviewClass * klass,
                                    gpointer klass_data)
{
	quilter_widgets_preview_parent_class = g_type_class_peek_parent (klass);
	((WebKitWebViewClass *) klass)->context_menu = (gboolean (*) (WebKitWebView*, WebKitContextMenu*, GdkEvent*, WebKitHitTestResult*)) quilter_widgets_preview_real_context_menu;
	G_OBJECT_CLASS (klass)->set_property = _vala_quilter_widgets_preview_set_property;
	G_OBJECT_CLASS (klass)->finalize = quilter_widgets_preview_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), QUILTER_WIDGETS_PREVIEW_SCROLL_VALUE_PROPERTY, quilter_widgets_preview_properties[QUILTER_WIDGETS_PREVIEW_SCROLL_VALUE_PROPERTY] = g_param_spec_double ("scroll-value", "scroll-value", "scroll-value", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
}

static void
quilter_widgets_preview_instance_init (QuilterWidgetsPreview * self,
                                       gpointer klass)
{
}

static void
quilter_widgets_preview_finalize (GObject * obj)
{
	QuilterWidgetsPreview * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, QUILTER_WIDGETS_TYPE_PREVIEW, QuilterWidgetsPreview);
	_g_object_unref0 (self->buf);
	_g_free0 (self->html);
	G_OBJECT_CLASS (quilter_widgets_preview_parent_class)->finalize (obj);
}

static GType
quilter_widgets_preview_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (QuilterWidgetsPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) quilter_widgets_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (QuilterWidgetsPreview), 0, (GInstanceInitFunc) quilter_widgets_preview_instance_init, NULL };
	GType quilter_widgets_preview_type_id;
	quilter_widgets_preview_type_id = g_type_register_static (webkit_web_view_get_type (), "QuilterWidgetsPreview", &g_define_type_info, 0);
	return quilter_widgets_preview_type_id;
}

GType
quilter_widgets_preview_get_type (void)
{
	static volatile gsize quilter_widgets_preview_type_id__volatile = 0;
	if (g_once_init_enter (&quilter_widgets_preview_type_id__volatile)) {
		GType quilter_widgets_preview_type_id;
		quilter_widgets_preview_type_id = quilter_widgets_preview_get_type_once ();
		g_once_init_leave (&quilter_widgets_preview_type_id__volatile, quilter_widgets_preview_type_id);
	}
	return quilter_widgets_preview_type_id__volatile;
}

static void
_vala_quilter_widgets_preview_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	QuilterWidgetsPreview * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, QUILTER_WIDGETS_TYPE_PREVIEW, QuilterWidgetsPreview);
	switch (property_id) {
		case QUILTER_WIDGETS_PREVIEW_SCROLL_VALUE_PROPERTY:
		quilter_widgets_preview_set_scroll_value (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

